'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var Reconciler = _interopDefault(require('react-reconciler'));
var React = _interopDefault(require('react'));
var ReactDOM = _interopDefault(require('react-dom'));
var antColonyUi = require('ant-colony-ui');
var reactRouterDom = require('react-router-dom');
var kittenjs = require('kittenjs');
var styled = _interopDefault(require('styled-components'));

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

var emptyObject = {};

if (process.env.NODE_ENV !== "production") {
  Object.freeze(emptyObject);
}

var emptyObject_1 = emptyObject;

/**
 * CSS properties which accept numbers but are not in units of "px".
 *
 * @NOTE: Taken from React source code
 * @url{https://github.com/facebook/react/blob/37e4329bc81def4695211d6e3795a654ef4d84f5/packages/react-dom/src/shared/CSSProperty.js}
 */
var unitlessCSSProperties = {
    animationIterationCount: true,
    borderImageOutset: true,
    borderImageSlice: true,
    borderImageWidth: true,
    boxFlex: true,
    boxFlexGroup: true,
    boxOrdinalGroup: true,
    columnCount: true,
    columns: true,
    flex: true,
    flexGrow: true,
    flexPositive: true,
    flexShrink: true,
    flexNegative: true,
    flexOrder: true,
    gridRow: true,
    gridRowEnd: true,
    gridRowSpan: true,
    gridRowStart: true,
    gridColumn: true,
    gridColumnEnd: true,
    gridColumnSpan: true,
    gridColumnStart: true,
    fontWeight: true,
    lineClamp: true,
    lineHeight: true,
    opacity: true,
    order: true,
    orphans: true,
    tabSize: true,
    widows: true,
    zIndex: true,
    zoom: true,
    // SVG-related properties
    fillOpacity: true,
    floodOpacity: true,
    stopOpacity: true,
    strokeDasharray: true,
    strokeDashoffset: true,
    strokeMiterlimit: true,
    strokeOpacity: true,
    strokeWidth: true,
};
function isUnitlessProperty(styleName) {
    return !!unitlessCSSProperties[styleName];
}

function _Table(dom, props) {
    // console.log('===TABLE-PROPS===:', props)
    ReactDOM.render(React.createElement(antColonyUi.Table, { columns: props.columns, dataSource: props.dataSource, rowKey: props.rowKey, scrollWidth: 1000, floatingScrollDomQuery: ".ant-table-scroll .ant-table-body", columnsConfigGlobalTableKey: "Kitten-Reconciler-UI-Table-" + props.appKey + "-" + props.pageKey }), dom);
}

function _Form(dom, props) {
    // console.log('===FORM-PROPS===:', props)
    ReactDOM.render(React.createElement(antColonyUi.Form, { forms: props.items, onSubmit: props.onSubmit, actionDirection: "right" }), dom);
}

function connectRoute(WrappedComponent, title) {
    return /** @class */ (function (_super) {
        __extends(ConnectRoute, _super);
        function ConnectRoute() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ConnectRoute.prototype.shouldComponentUpdate = function (nextProps) {
            return nextProps.location !== this.props.location;
        };
        ConnectRoute.prototype.componentDidMount = function () {
            document.title = title;
        };
        ConnectRoute.prototype.render = function () {
            return React.createElement(WrappedComponent, __assign({}, this.props));
        };
        return ConnectRoute;
    }(React.Component));
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function isAbsolute(pathname) {
  return pathname.charAt(0) === '/';
}

// About 1.5x faster than the two-arg version of Array#splice()
function spliceOne(list, index) {
  for (var i = index, k = i + 1, n = list.length; k < n; i += 1, k += 1) {
    list[i] = list[k];
  }

  list.pop();
}

// This implementation is based heavily on node's url.parse
function resolvePathname(to) {
  var from = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  var toParts = to && to.split('/') || [];
  var fromParts = from && from.split('/') || [];

  var isToAbs = to && isAbsolute(to);
  var isFromAbs = from && isAbsolute(from);
  var mustEndAbs = isToAbs || isFromAbs;

  if (to && isAbsolute(to)) {
    // to is absolute
    fromParts = toParts;
  } else if (toParts.length) {
    // to is relative, drop the filename
    fromParts.pop();
    fromParts = fromParts.concat(toParts);
  }

  if (!fromParts.length) return '/';

  var hasTrailingSlash = void 0;
  if (fromParts.length) {
    var last = fromParts[fromParts.length - 1];
    hasTrailingSlash = last === '.' || last === '..' || last === '';
  } else {
    hasTrailingSlash = false;
  }

  var up = 0;
  for (var i = fromParts.length; i >= 0; i--) {
    var part = fromParts[i];

    if (part === '.') {
      spliceOne(fromParts, i);
    } else if (part === '..') {
      spliceOne(fromParts, i);
      up++;
    } else if (up) {
      spliceOne(fromParts, i);
      up--;
    }
  }

  if (!mustEndAbs) for (; up--; up) {
    fromParts.unshift('..');
  }if (mustEndAbs && fromParts[0] !== '' && (!fromParts[0] || !isAbsolute(fromParts[0]))) fromParts.unshift('');

  var result = fromParts.join('/');

  if (hasTrailingSlash && result.substr(-1) !== '/') result += '/';

  return result;
}

var isProduction = process.env.NODE_ENV === 'production';
function warning(condition, message) {
  if (!isProduction) {
    if (condition) {
      return;
    }

    var text = "Warning: " + message;

    if (typeof console !== 'undefined') {
      console.warn(text);
    }

    try {
      throw Error(text);
    } catch (x) {}
  }
}

var isProduction$1 = process.env.NODE_ENV === 'production';
var prefix = 'Invariant failed';
function invariant(condition, message) {
  if (condition) {
    return;
  }

  if (isProduction$1) {
    throw new Error(prefix);
  } else {
    throw new Error(prefix + ": " + (message || ''));
  }
}

function addLeadingSlash(path) {
  return path.charAt(0) === '/' ? path : '/' + path;
}
function hasBasename(path, prefix) {
  return new RegExp('^' + prefix + '(\\/|\\?|#|$)', 'i').test(path);
}
function stripBasename(path, prefix) {
  return hasBasename(path, prefix) ? path.substr(prefix.length) : path;
}
function stripTrailingSlash(path) {
  return path.charAt(path.length - 1) === '/' ? path.slice(0, -1) : path;
}
function parsePath(path) {
  var pathname = path || '/';
  var search = '';
  var hash = '';
  var hashIndex = pathname.indexOf('#');

  if (hashIndex !== -1) {
    hash = pathname.substr(hashIndex);
    pathname = pathname.substr(0, hashIndex);
  }

  var searchIndex = pathname.indexOf('?');

  if (searchIndex !== -1) {
    search = pathname.substr(searchIndex);
    pathname = pathname.substr(0, searchIndex);
  }

  return {
    pathname: pathname,
    search: search === '?' ? '' : search,
    hash: hash === '#' ? '' : hash
  };
}
function createPath(location) {
  var pathname = location.pathname,
      search = location.search,
      hash = location.hash;
  var path = pathname || '/';
  if (search && search !== '?') path += search.charAt(0) === '?' ? search : "?" + search;
  if (hash && hash !== '#') path += hash.charAt(0) === '#' ? hash : "#" + hash;
  return path;
}

function createLocation(path, state, key, currentLocation) {
  var location;

  if (typeof path === 'string') {
    // Two-arg form: push(path, state)
    location = parsePath(path);
    location.state = state;
  } else {
    // One-arg form: push(location)
    location = _extends({}, path);
    if (location.pathname === undefined) location.pathname = '';

    if (location.search) {
      if (location.search.charAt(0) !== '?') location.search = '?' + location.search;
    } else {
      location.search = '';
    }

    if (location.hash) {
      if (location.hash.charAt(0) !== '#') location.hash = '#' + location.hash;
    } else {
      location.hash = '';
    }

    if (state !== undefined && location.state === undefined) location.state = state;
  }

  try {
    location.pathname = decodeURI(location.pathname);
  } catch (e) {
    if (e instanceof URIError) {
      throw new URIError('Pathname "' + location.pathname + '" could not be decoded. ' + 'This is likely caused by an invalid percent-encoding.');
    } else {
      throw e;
    }
  }

  if (key) location.key = key;

  if (currentLocation) {
    // Resolve incomplete/relative pathname relative to current location.
    if (!location.pathname) {
      location.pathname = currentLocation.pathname;
    } else if (location.pathname.charAt(0) !== '/') {
      location.pathname = resolvePathname(location.pathname, currentLocation.pathname);
    }
  } else {
    // When there is no prior location and pathname is empty, set it to /
    if (!location.pathname) {
      location.pathname = '/';
    }
  }

  return location;
}

function createTransitionManager() {
  var prompt = null;

  function setPrompt(nextPrompt) {
    process.env.NODE_ENV !== "production" ? warning(prompt == null, 'A history supports only one prompt at a time') : void 0;
    prompt = nextPrompt;
    return function () {
      if (prompt === nextPrompt) prompt = null;
    };
  }

  function confirmTransitionTo(location, action, getUserConfirmation, callback) {
    // TODO: If another transition starts while we're still confirming
    // the previous one, we may end up in a weird state. Figure out the
    // best way to handle this.
    if (prompt != null) {
      var result = typeof prompt === 'function' ? prompt(location, action) : prompt;

      if (typeof result === 'string') {
        if (typeof getUserConfirmation === 'function') {
          getUserConfirmation(result, callback);
        } else {
          process.env.NODE_ENV !== "production" ? warning(false, 'A history needs a getUserConfirmation function in order to use a prompt message') : void 0;
          callback(true);
        }
      } else {
        // Return false from a transition hook to cancel the transition.
        callback(result !== false);
      }
    } else {
      callback(true);
    }
  }

  var listeners = [];

  function appendListener(fn) {
    var isActive = true;

    function listener() {
      if (isActive) fn.apply(void 0, arguments);
    }

    listeners.push(listener);
    return function () {
      isActive = false;
      listeners = listeners.filter(function (item) {
        return item !== listener;
      });
    };
  }

  function notifyListeners() {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    listeners.forEach(function (listener) {
      return listener.apply(void 0, args);
    });
  }

  return {
    setPrompt: setPrompt,
    confirmTransitionTo: confirmTransitionTo,
    appendListener: appendListener,
    notifyListeners: notifyListeners
  };
}

var canUseDOM = !!(typeof window !== 'undefined' && window.document && window.document.createElement);
function getConfirmation(message, callback) {
  callback(window.confirm(message)); // eslint-disable-line no-alert
}
/**
 * Returns true if the HTML5 history API is supported. Taken from Modernizr.
 *
 * https://github.com/Modernizr/Modernizr/blob/master/LICENSE
 * https://github.com/Modernizr/Modernizr/blob/master/feature-detects/history.js
 * changed to avoid false negatives for Windows Phones: https://github.com/reactjs/react-router/issues/586
 */

function supportsHistory() {
  var ua = window.navigator.userAgent;
  if ((ua.indexOf('Android 2.') !== -1 || ua.indexOf('Android 4.0') !== -1) && ua.indexOf('Mobile Safari') !== -1 && ua.indexOf('Chrome') === -1 && ua.indexOf('Windows Phone') === -1) return false;
  return window.history && 'pushState' in window.history;
}
/**
 * Returns true if browser fires popstate on hash change.
 * IE10 and IE11 do not.
 */

function supportsPopStateOnHashChange() {
  return window.navigator.userAgent.indexOf('Trident') === -1;
}
/**
 * Returns true if a given popstate event is an extraneous WebKit event.
 * Accounts for the fact that Chrome on iOS fires real popstate events
 * containing undefined state when pressing the back button.
 */

function isExtraneousPopstateEvent(event) {
  event.state === undefined && navigator.userAgent.indexOf('CriOS') === -1;
}

var PopStateEvent = 'popstate';
var HashChangeEvent = 'hashchange';

function getHistoryState() {
  try {
    return window.history.state || {};
  } catch (e) {
    // IE 11 sometimes throws when accessing window.history.state
    // See https://github.com/ReactTraining/history/pull/289
    return {};
  }
}
/**
 * Creates a history object that uses the HTML5 history API including
 * pushState, replaceState, and the popstate event.
 */


function createBrowserHistory(props) {
  if (props === void 0) {
    props = {};
  }

  !canUseDOM ? process.env.NODE_ENV !== "production" ? invariant(false, 'Browser history needs a DOM') : invariant(false) : void 0;
  var globalHistory = window.history;
  var canUseHistory = supportsHistory();
  var needsHashChangeListener = !supportsPopStateOnHashChange();
  var _props = props,
      _props$forceRefresh = _props.forceRefresh,
      forceRefresh = _props$forceRefresh === void 0 ? false : _props$forceRefresh,
      _props$getUserConfirm = _props.getUserConfirmation,
      getUserConfirmation = _props$getUserConfirm === void 0 ? getConfirmation : _props$getUserConfirm,
      _props$keyLength = _props.keyLength,
      keyLength = _props$keyLength === void 0 ? 6 : _props$keyLength;
  var basename = props.basename ? stripTrailingSlash(addLeadingSlash(props.basename)) : '';

  function getDOMLocation(historyState) {
    var _ref = historyState || {},
        key = _ref.key,
        state = _ref.state;

    var _window$location = window.location,
        pathname = _window$location.pathname,
        search = _window$location.search,
        hash = _window$location.hash;
    var path = pathname + search + hash;
    process.env.NODE_ENV !== "production" ? warning(!basename || hasBasename(path, basename), 'You are attempting to use a basename on a page whose URL path does not begin ' + 'with the basename. Expected path "' + path + '" to begin with "' + basename + '".') : void 0;
    if (basename) path = stripBasename(path, basename);
    return createLocation(path, state, key);
  }

  function createKey() {
    return Math.random().toString(36).substr(2, keyLength);
  }

  var transitionManager = createTransitionManager();

  function setState(nextState) {
    _extends(history, nextState);

    history.length = globalHistory.length;
    transitionManager.notifyListeners(history.location, history.action);
  }

  function handlePopState(event) {
    // Ignore extraneous popstate events in WebKit.
    if (isExtraneousPopstateEvent(event)) return;
    handlePop(getDOMLocation(event.state));
  }

  function handleHashChange() {
    handlePop(getDOMLocation(getHistoryState()));
  }

  var forceNextPop = false;

  function handlePop(location) {
    if (forceNextPop) {
      forceNextPop = false;
      setState();
    } else {
      var action = 'POP';
      transitionManager.confirmTransitionTo(location, action, getUserConfirmation, function (ok) {
        if (ok) {
          setState({
            action: action,
            location: location
          });
        } else {
          revertPop(location);
        }
      });
    }
  }

  function revertPop(fromLocation) {
    var toLocation = history.location; // TODO: We could probably make this more reliable by
    // keeping a list of keys we've seen in sessionStorage.
    // Instead, we just default to 0 for keys we don't know.

    var toIndex = allKeys.indexOf(toLocation.key);
    if (toIndex === -1) toIndex = 0;
    var fromIndex = allKeys.indexOf(fromLocation.key);
    if (fromIndex === -1) fromIndex = 0;
    var delta = toIndex - fromIndex;

    if (delta) {
      forceNextPop = true;
      go(delta);
    }
  }

  var initialLocation = getDOMLocation(getHistoryState());
  var allKeys = [initialLocation.key]; // Public interface

  function createHref(location) {
    return basename + createPath(location);
  }

  function push(path, state) {
    process.env.NODE_ENV !== "production" ? warning(!(typeof path === 'object' && path.state !== undefined && state !== undefined), 'You should avoid providing a 2nd state argument to push when the 1st ' + 'argument is a location-like object that already has state; it is ignored') : void 0;
    var action = 'PUSH';
    var location = createLocation(path, state, createKey(), history.location);
    transitionManager.confirmTransitionTo(location, action, getUserConfirmation, function (ok) {
      if (!ok) return;
      var href = createHref(location);
      var key = location.key,
          state = location.state;

      if (canUseHistory) {
        globalHistory.pushState({
          key: key,
          state: state
        }, null, href);

        if (forceRefresh) {
          window.location.href = href;
        } else {
          var prevIndex = allKeys.indexOf(history.location.key);
          var nextKeys = allKeys.slice(0, prevIndex === -1 ? 0 : prevIndex + 1);
          nextKeys.push(location.key);
          allKeys = nextKeys;
          setState({
            action: action,
            location: location
          });
        }
      } else {
        process.env.NODE_ENV !== "production" ? warning(state === undefined, 'Browser history cannot push state in browsers that do not support HTML5 history') : void 0;
        window.location.href = href;
      }
    });
  }

  function replace(path, state) {
    process.env.NODE_ENV !== "production" ? warning(!(typeof path === 'object' && path.state !== undefined && state !== undefined), 'You should avoid providing a 2nd state argument to replace when the 1st ' + 'argument is a location-like object that already has state; it is ignored') : void 0;
    var action = 'REPLACE';
    var location = createLocation(path, state, createKey(), history.location);
    transitionManager.confirmTransitionTo(location, action, getUserConfirmation, function (ok) {
      if (!ok) return;
      var href = createHref(location);
      var key = location.key,
          state = location.state;

      if (canUseHistory) {
        globalHistory.replaceState({
          key: key,
          state: state
        }, null, href);

        if (forceRefresh) {
          window.location.replace(href);
        } else {
          var prevIndex = allKeys.indexOf(history.location.key);
          if (prevIndex !== -1) allKeys[prevIndex] = location.key;
          setState({
            action: action,
            location: location
          });
        }
      } else {
        process.env.NODE_ENV !== "production" ? warning(state === undefined, 'Browser history cannot replace state in browsers that do not support HTML5 history') : void 0;
        window.location.replace(href);
      }
    });
  }

  function go(n) {
    globalHistory.go(n);
  }

  function goBack() {
    go(-1);
  }

  function goForward() {
    go(1);
  }

  var listenerCount = 0;

  function checkDOMListeners(delta) {
    listenerCount += delta;

    if (listenerCount === 1 && delta === 1) {
      window.addEventListener(PopStateEvent, handlePopState);
      if (needsHashChangeListener) window.addEventListener(HashChangeEvent, handleHashChange);
    } else if (listenerCount === 0) {
      window.removeEventListener(PopStateEvent, handlePopState);
      if (needsHashChangeListener) window.removeEventListener(HashChangeEvent, handleHashChange);
    }
  }

  var isBlocked = false;

  function block(prompt) {
    if (prompt === void 0) {
      prompt = false;
    }

    var unblock = transitionManager.setPrompt(prompt);

    if (!isBlocked) {
      checkDOMListeners(1);
      isBlocked = true;
    }

    return function () {
      if (isBlocked) {
        isBlocked = false;
        checkDOMListeners(-1);
      }

      return unblock();
    };
  }

  function listen(listener) {
    var unlisten = transitionManager.appendListener(listener);
    checkDOMListeners(1);
    return function () {
      checkDOMListeners(-1);
      unlisten();
    };
  }

  var history = {
    length: globalHistory.length,
    action: 'POP',
    location: initialLocation,
    createHref: createHref,
    push: push,
    replace: replace,
    go: go,
    goBack: goBack,
    goForward: goForward,
    block: block,
    listen: listen
  };
  return history;
}

var history = createBrowserHistory();
function _Layout(dom, props) {
    // console.log('===LAYOUT-PROPS===:', props)
    var config = props.config;
    var menus = config.menus;
    var pageLinks = [];
    var getPageLink = function (item) {
        var EntryComponent = connectRoute(kittenjs.Entry, item.label + " | " + config.appTitle);
        return {
            page: function (ps) {
                return (React.createElement(EntryComponent, __assign({}, props, ps, { title: item.label, pageKey: item.key, pageJSON: item.pageJSON })));
            },
            label: item.label,
            link: item.params
                ? "/" + item.key + "/:" + item.params.join(':')
                : "/" + item.key,
            index: !!item.index,
        };
    };
    menus.forEach(function (m) {
        if (kittenjs.isMenuGroup(m)) {
            m.subs.forEach(function (s) {
                if (kittenjs.isMenuGroup(s)) {
                    s.subs.forEach(function (ss) {
                        if (ss.key) {
                            pageLinks.push(getPageLink(ss));
                        }
                        else {
                            throw new Error('Menus Json 不合法，缺少字段 key');
                        }
                    });
                }
                else if (s.key) {
                    pageLinks.push(getPageLink(s));
                }
                else {
                    throw new Error('Menus Json 不合法，缺少字段 key');
                }
            });
        }
        else if (m.key) {
            pageLinks.push(getPageLink(m));
        }
        else {
            throw new Error('Menus Json 不合法，缺少字段 key 或 subs');
        }
    });
    var renderRoutes = function (pls) {
        return pls.map(function (p) {
            var exact = false;
            var redirect = false;
            if (p.link === '/')
                exact = true;
            if (p.link !== '/' && p.index)
                redirect = true;
            if (typeof p.page === 'function' && p.page.name !== 'ConnectRoute') {
                if (redirect) {
                    return (React.createElement(React.Fragment, { key: p.link },
                        React.createElement(reactRouterDom.Route, { exact: true, path: "/", render: function () { return React.createElement(reactRouterDom.Redirect, { to: p.link }); } }),
                        React.createElement(reactRouterDom.Route, { exact: exact, path: p.link, render: p.page })));
                }
                else {
                    return React.createElement(reactRouterDom.Route, { key: p.link, exact: exact, path: p.link, render: p.page });
                }
            }
            else {
                if (redirect) {
                    return (React.createElement(React.Fragment, { key: p.link },
                        React.createElement(reactRouterDom.Route, { exact: true, path: "/", component: function () { return React.createElement(reactRouterDom.Redirect, { to: p.link }); } }),
                        React.createElement(reactRouterDom.Route, { exact: exact, path: p.link, component: p.page })));
                }
                else {
                    return React.createElement(reactRouterDom.Route, { key: p.link, exact: exact, path: p.link, component: p.page });
                }
            }
        });
    };
    ReactDOM.render(React.createElement(antColonyUi.Frame, { title: config.appTitle, collapsedTitle: config.appKey, menus: menus, didMount: function (node) {
            ReactUI.render(React.createElement(reactRouterDom.Router, { history: history }, renderRoutes(pageLinks)), node, function () { });
        }, onMenuSelect: function (key) {
            history.push(key);
        } }), dom, function () { });
}

var AppAlert = styled(antColonyUi.Alert)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    &.ant-alert-with-description {\n        position: fixed;\n        top: 64px;\n        width: 100%;\n    }\n    &.ant-alert {\n        position: fixed;\n        top: 64px;\n        width: calc(100% - 220px);\n        margin-left: -10px;\n        margin-top: 10px;\n    }\n    z-index: 150;\n"], ["\n    &.ant-alert-with-description {\n        position: fixed;\n        top: 64px;\n        width: 100%;\n    }\n    &.ant-alert {\n        position: fixed;\n        top: 64px;\n        width: calc(100% - 220px);\n        margin-left: -10px;\n        margin-top: 10px;\n    }\n    z-index: 150;\n"])));
function _Alert(dom, props) {
    // console.log('===ALERT-PROPS===:', props)
    ReactDOM.render(React.createElement(AppAlert, { type: props.type, messge: props.messge, description: props.description, onClose: props.onClose }), dom);
}
var templateObject_1;

function _Loading(dom, props) {
    // console.log('===LOADING-PROPS===:', props)
    ReactDOM.render(React.createElement(antColonyUi.Loading, { show: props.show, type: props.type, timeout: props.timeout }), dom);
}

var _a = require('scheduler'), unstable_cancelCallback = _a.unstable_cancelCallback, unstable_scheduleCallback = _a.unstable_scheduleCallback;
function setStyles(domElement, styles) {
    if (!styles)
        return;
    Object.keys(styles).forEach(function (name) {
        var rawValue = styles[name];
        var isEmpty = rawValue === null ||
            typeof rawValue === 'boolean' ||
            rawValue === '';
        // Unset the style to its default values using an empty string
        if (isEmpty)
            domElement.style[name] = '';
        else {
            var value = typeof rawValue === 'number' && !isUnitlessProperty(name)
                ? rawValue + "px"
                : rawValue;
            domElement.style[name] = value;
        }
    });
}
function shallowDiff(oldObj, newObj) {
    // Return a diff between the new and the old object
    var uniqueProps = new Set(__spread(Object.keys(oldObj), Object.keys(newObj)));
    var changedProps = Array.from(uniqueProps).filter(function (propName) { return oldObj[propName] !== newObj[propName]; });
    return changedProps;
}
function isEventName(propName) {
    return (propName.startsWith('on') &&
        window.hasOwnProperty(propName.toLowerCase()));
}
var hostConfig = {
    // appendChild for direct children
    appendInitialChild: function (parentInstance, child) {
        parentInstance.appendChild(child);
    },
    // Create the DOMElement, but attributes are set in `finalizeInitialChildren`
    createInstance: function (type, props, rootContainerInstance, hostContext, internalInstanceHandle) {
        var domElement = null;
        switch (type) {
            case 'layout':
                domElement = document.createElement('div');
                _Layout(domElement, props);
                break;
            case 'page':
                domElement = document.createElement('div');
                break;
            case 'table':
                domElement = document.createElement('div');
                _Table(domElement, props);
                break;
            case 'form':
                domElement = document.createElement('div');
                _Form(domElement, props);
                break;
            case 'alert':
                domElement = document.createElement('div');
                _Alert(domElement, props);
                break;
            case 'loading':
                domElement = document.createElement('div');
                _Loading(domElement, props);
                break;
            default:
                domElement = document.createElement(type);
        }
        return domElement;
    },
    createTextInstance: function (text, rootContainerInstance, internalInstanceHandle) {
        // A TextNode instance is returned because literal strings cannot change their value later on update
        return document.createTextNode(text);
    },
    // Actually set the attributes and text content to the domElement and check if
    // it needs focus, which will be eventually set in `commitMount`
    finalizeInitialChildren: function (domElement, type, props) {
        // Set the prop to the domElement
        Object.keys(props).forEach(function (propName) {
            var propValue = props[propName];
            if (propName === 'style') {
                setStyles(domElement, propValue);
            }
            else if (propName === 'children') {
                // Set the textContent only for literal string or number children, whereas
                // nodes will be appended in `appendChild`
                if (typeof propValue === 'string' ||
                    typeof propValue === 'number') {
                    domElement.textContent = propValue + '';
                }
            }
            else if (propName === 'className') {
                domElement.setAttribute('class', propValue);
            }
            else if (isEventName(propName)) {
                var eventName = propName.toLowerCase().replace('on', '');
                domElement.addEventListener(eventName, propValue);
            }
            else {
                domElement.setAttribute(propName, propValue);
            }
        });
        // Check if needs focus
        switch (type) {
            case 'button':
            case 'input':
            case 'select':
            case 'textarea':
                return !!props.autoFocus;
        }
        return false;
    },
    // Useful only for testing
    getPublicInstance: function (inst) {
        return inst;
    },
    // Commit hooks, useful mainly for react-dom syntethic events
    prepareForCommit: function () { },
    resetAfterCommit: function () { },
    // Calculate the updatePayload
    prepareUpdate: function (domElement, type, oldProps, newProps) {
        // Return a diff between the new and the old props
        return shallowDiff(oldProps, newProps);
    },
    getRootHostContext: function (rootInstance) {
        return emptyObject_1;
    },
    getChildHostContext: function (parentHostContext, type) {
        return emptyObject_1;
    },
    shouldSetTextContent: function (type, props) {
        return (type === 'textarea' ||
            typeof props.children === 'string' ||
            typeof props.children === 'number');
    },
    now: function () {
        return Date.now();
    },
    supportsMutation: true,
    appendChild: function (parentInstance, child) {
        parentInstance.appendChild(child);
    },
    // appendChild to root container
    appendChildToContainer: function (parentInstance, child) {
        parentInstance.appendChild(child);
    },
    removeChild: function (parentInstance, child) {
        parentInstance.removeChild(child);
    },
    removeChildFromContainer: function (parentInstance, child) {
        parentInstance.removeChild(child);
    },
    insertBefore: function (parentInstance, child, beforeChild) {
        parentInstance.insertBefore(child, beforeChild);
    },
    insertInContainerBefore: function (parentInstance, child, beforeChild) {
        parentInstance.insertBefore(child, beforeChild);
    },
    commitUpdate: function (domElement, updatePayload, type, oldProps, newProps, internalInstanceHandle) {
        var realDom = domElement;
        switch (type) {
            case 'layout':
                _Layout(domElement, newProps);
                break;
            case 'table':
                _Table(domElement, newProps);
                break;
            case 'form':
                _Form(domElement, newProps);
                break;
            case 'alert':
                _Alert(domElement, newProps);
                break;
            case 'loading':
                _Loading(domElement, newProps);
                break;
        }
        updatePayload.forEach(function (propName) {
            // children changes is done by the other methods like `commitTextUpdate`
            if (propName === 'children')
                return;
            if (propName === 'style') {
                // Return a diff between the new and the old styles
                var styleDiffs = shallowDiff(oldProps.style, newProps.style);
                var finalStyles = styleDiffs.reduce(function (acc, styleName) {
                    // Style marked to be unset
                    if (!newProps.style[styleName])
                        acc[styleName] = '';
                    else
                        acc[styleName] = newProps.style[styleName];
                    return acc;
                }, {});
                setStyles(realDom, finalStyles);
            }
            else if (newProps[propName] ||
                typeof newProps[propName] === 'number') {
                realDom.setAttribute(propName, newProps[propName]);
            }
            else {
                if (isEventName(propName)) {
                    var eventName = propName.toLowerCase().replace('on', '');
                    realDom.removeEventListener(eventName, oldProps[propName]);
                }
                else {
                    realDom.removeAttribute(propName);
                }
            }
        });
    },
    commitMount: function (domElement, type, newProps, internalInstanceHandle) {
        domElement.focus();
    },
    commitTextUpdate: function (textInstance, oldText, newText) {
        textInstance.nodeValue = newText;
    },
    resetTextContent: function (domElement) {
        domElement.textContent = '';
    },
    shouldDeprioritizeSubtree: function (type, props) {
        return false;
    },
    scheduleDeferredCallback: function (callback, options) {
        var fakeCallbackId = 0;
        return fakeCallbackId;
    },
    cancelDeferredCallback: function (timeoutID) {
    },
    schedulePassiveEffects: unstable_scheduleCallback,
    cancelPassiveEffects: unstable_cancelCallback,
    setTimeout: function (handler) { return -1; },
    clearTimeout: function (handle) { },
    noTimeout: -1,
    isPrimaryRenderer: false,
    supportsHydration: false,
    supportsPersistence: false
};
// const UIRenderer = Reconciler(
//     debugMethods(hostConfig, [
//         'now',
//         'getChildHostContext',
//         'shouldSetTextContent',
//     ]),
// );
var UIRenderer = Reconciler(hostConfig);
var ReactUI = {
    render: function (element, domContainer, callback) {
        var root = domContainer._reactRootContainer;
        if (!root) {
            // Remove all children of the domContainer
            var rootSibling = void 0;
            while ((rootSibling = domContainer.lastChild)) {
                domContainer.removeChild(rootSibling);
            }
            var newRoot = UIRenderer.createContainer(domContainer, false, false);
            root = domContainer._reactRootContainer = newRoot;
        }
        return UIRenderer.updateContainer(element, root, null, callback);
    },
};

exports.default = ReactUI;
//# sourceMappingURL=index.js.map
